/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.log.Logger
 *  fire.pb.activity.ActivityConfNew
 *  fire.pb.game.ImperialExamProvinceRepo
 *  fire.pb.game.ImperialExamStateRepo
 *  fire.pb.game.ImperialExamVillageRepo
 *  fire.pb.mission.SRemoveTuiSong
 *  fire.pb.mission.activelist.RoleLiveness
 *  fire.pb.npc.NpcManager
 *  fire.pb.talk.MessageMgr
 *  fire.pb.util.DateValidate
 *  fire.pb.util.Misc
 *  mkdb.Procedure
 *  mkio.Protocol
 *  xbean.ImpExamRecord
 *  xbean.ImpExamStateRecord
 *  xbean.Pod
 *  xtable.Impexamstatetbl
 *  xtable.Properties
 *  xtable.Role2impexam
 */
package fire.pb.activity.impexam;

import fire.log.Logger;
import fire.pb.activity.ActivityConfNew;
import fire.pb.activity.impexam.ImpExamConst;
import fire.pb.activity.impexam.ImpExamManager;
import fire.pb.game.ImperialExamProvinceRepo;
import fire.pb.game.ImperialExamStateRepo;
import fire.pb.game.ImperialExamVillageRepo;
import fire.pb.mission.SRemoveTuiSong;
import fire.pb.mission.activelist.RoleLiveness;
import fire.pb.npc.NpcManager;
import fire.pb.talk.MessageMgr;
import fire.pb.util.DateValidate;
import fire.pb.util.Misc;
import java.util.List;
import java.util.NavigableMap;
import mkdb.Procedure;
import mkio.Protocol;
import xbean.ImpExamRecord;
import xbean.ImpExamStateRecord;
import xbean.Pod;
import xtable.Impexamstatetbl;
import xtable.Properties;
import xtable.Role2impexam;

public class PApplyImpExamProc
extends Procedure {
    private final long roleId;
    private final int type;
    private final int operate;
    private static Logger logger = Logger.getLogger((String)"SYSTEM");

    public PApplyImpExamProc(long roleId, int type, int operate) {
        this.roleId = roleId;
        this.type = type;
        this.operate = operate;
    }

    protected boolean process() throws Exception {
        boolean isIe = ImpExamManager.getInstance().isImpExamTime(this.type);
        if (!isIe) {
            MessageMgr.psendMsgNotifyWhileRollback((long)this.roleId, (int)140434, null);
            return false;
        }
        if (!ImpExamManager.getInstance().answerCheck(this.roleId)) {
            return false;
        }
        ImpExamRecord record = Role2impexam.get((Long)this.roleId);
        if (record == null) {
            record = Pod.newImpExamRecord();
            Role2impexam.insert((Long)this.roleId, (ImpExamRecord)record);
        }
        if (this.type == 1) {
            return this.processVillExam(record);
        }
        if (this.type == 2) {
            return this.processProvExam(record);
        }
        if (this.type == 3) {
            return this.processStateExam(record);
        }
        return false;
    }

    private boolean processVillExam(ImpExamRecord record) {
        int flag = record.getFlag();
        long cur = System.currentTimeMillis();
        ActivityConfNew activity = RoleLiveness.getConfigActivity((int)214);
        int roleLv = Properties.selectLevel((Long)this.roleId);
        if (roleLv < activity.level) {
            return false;
        }
        if (!DateValidate.inTheSameWeek((long)cur, (long)record.getBegintime())) {
            record.setCurrexamaccright(0);
            record.setDelwrongval(0);
            record.setChorightval(0);
            record.setHelpcnt(0);
        }
        if (!DateValidate.inTheSameDay((long)cur, (long)record.getBegintime()) || ImpExamManager.test) {
            record.getQuesidlist().clear();
            NavigableMap keju1RepositoryMap = NpcManager.getInstance().getKeju1RepositoryMap();
            Integer[] dest = Misc.getRandomValues((int)1, (int)keju1RepositoryMap.size(), (int)ImpExamConst.IMPEXAM_VILL_QUESIZE).toArray(new Integer[ImpExamConst.IMPEXAM_VILL_QUESIZE]);
            List qIDList = record.getQuesidlist();
            for (int i = 0; i < dest.length; ++i) {
                qIDList.add(dest[i]);
            }
            ImperialExamVillageRepo rep = (ImperialExamVillageRepo)keju1RepositoryMap.get(qIDList.get(0));
            record.setLastanswer(rep.getAnswer());
            record.setLastquesid(0);
            record.setBegintime(cur);
            record.setFlag(1);
            record.setStep(1);
            record.setLastisright(-1);
            record.setMaxcontinueright(0);
            record.setCurrexamaccexp(0);
            record.setCurrexamaccmoney(0);
            record.setAccrightnum(0);
            record.setCurrexamaccright(0);
            record.setHelpcnt(0);
            flag = record.getFlag();
        } else if (flag != 1) {
            MessageMgr.psendMsgNotifyWhileRollback((long)this.roleId, (int)143812, null);
            return false;
        }
        ImpExamManager.getInstance().sendVillExamQuestion(this.roleId, record, 0);
        return true;
    }

    private boolean processProvExam(ImpExamRecord record) {
        int flag = record.getFlag();
        long cur = System.currentTimeMillis();
        int step = record.getStep();
        ActivityConfNew activity = RoleLiveness.getConfigActivity((int)215);
        int roleLv = Properties.selectLevel((Long)this.roleId);
        if (roleLv < activity.level) {
            return false;
        }
        if (!DateValidate.inTheSameDay((long)cur, (long)record.getBegintime()) || ImpExamManager.test) {
            record.getQuesidlist().clear();
            NavigableMap keju2RepositoryMap = NpcManager.getInstance().getKeju2RepositoryMap();
            Integer[] dest = Misc.getRandomValues((int)1, (int)keju2RepositoryMap.size(), (int)ImpExamConst.IMPEXAM_PROV_QUESIZE).toArray(new Integer[ImpExamConst.IMPEXAM_PROV_QUESIZE]);
            List qIDList = record.getQuesidlist();
            for (int i = 0; i < dest.length; ++i) {
                qIDList.add(dest[i]);
            }
            ImperialExamProvinceRepo rep = (ImperialExamProvinceRepo)keju2RepositoryMap.get(qIDList.get(0));
            record.setLastanswer(rep.getAnswer());
            record.setLastquesid(0);
            record.setBegintime(cur);
            record.setFlag(1);
            record.setStep(2);
            record.setLastisright(-1);
            record.getRightquesmap().put(1, 0);
            record.getRightquesmap().put(2, 0);
            record.getRightquesmap().put(3, 0);
            record.getRightquesmap().put(4, 0);
            record.setMaxcontinueright(0);
            record.setCurrexamaccexp(0);
            record.setCurrexamaccmoney(0);
            record.setAccrightnum(0);
            record.setCurrexamaccright(0);
            flag = record.getFlag();
            logger.debug((Object)("ProvExam roleid:" + this.roleId + " quesid:" + rep.id + " answer:" + rep.answer));
            List wrongQuesList = record.getWorngqueslist();
            for (int i = 1; i <= 4; ++i) {
                if (rep.getAnswer() == i) continue;
                wrongQuesList.add(i);
                logger.debug((Object)("ProvExam roleid:" + this.roleId + " quesid:" + rep.id + " wronganswer:" + i));
            }
        } else if (flag != 1) {
            MessageMgr.psendMsgNotifyWhileRollback((long)this.roleId, (int)143812, null);
            return false;
        }
        if ((step = record.getStep()) != 2) {
            return false;
        }
        record.setExamsendquestime(cur);
        ImpExamManager.getInstance().sendProvExamQuestion(this.roleId, record, 0);
        return true;
    }

    private boolean processStateExam(ImpExamRecord record) {
        int flag = record.getFlag();
        long cur = System.currentTimeMillis();
        int step = record.getStep();
        ImpExamStateRecord iesRecord = null;
        iesRecord = Impexamstatetbl.get((Integer)1);
        if (iesRecord == null) {
            return false;
        }
        if (!iesRecord.getIdslist().contains(this.roleId)) {
            MessageMgr.psendMsgNotifyWhileRollback((long)this.roleId, (int)190013, null);
        }
        if (!DateValidate.inTheSameDay((long)cur, (long)record.getBegintime()) || ImpExamManager.test) {
            if (this.operate == 0 && this.type == 3) {
                ImpExamManager.getInstance().sendImpExamStart(this.roleId, record, 3);
                return true;
            }
            record.getQuesidlist().clear();
            NavigableMap keju3RepositoryMap = NpcManager.getInstance().getKeju3RepositoryMap();
            Integer[] dest = Misc.getRandomValues((int)1, (int)keju3RepositoryMap.size(), (int)ImpExamConst.IMPEXAM_STATE_QUESIZE).toArray(new Integer[ImpExamConst.IMPEXAM_STATE_QUESIZE]);
            List qIDList = record.getQuesidlist();
            for (int i = 0; i < dest.length; ++i) {
                qIDList.add(dest[i]);
            }
            ImperialExamStateRepo rep = (ImperialExamStateRepo)keju3RepositoryMap.get(qIDList.get(0));
            record.setLastanswer(rep.getAnswer());
            record.setLastquesid(0);
            record.setBegintime(cur);
            record.setFlag(1);
            record.setStep(2);
            record.setLastisright(-1);
            record.getRightquesmap().put(1, 0);
            record.getRightquesmap().put(2, 0);
            record.getRightquesmap().put(3, 0);
            record.getRightquesmap().put(4, 0);
            record.setMaxcontinueright(0);
            record.setCurrexamaccexp(0);
            record.setCurrexamaccmoney(0);
            record.setAccrightnum(0);
            record.setCurrexamaccright(0);
            flag = record.getFlag();
        } else if (flag != 1) {
            MessageMgr.psendMsgNotifyWhileRollback((long)this.roleId, (int)143812, null);
            return false;
        }
        step = record.getStep();
        if (step != 3) {
            return false;
        }
        ImpExamManager.getInstance().sendStateExamQuestion(this.roleId, record, 0);
        SRemoveTuiSong send = new SRemoveTuiSong();
        send.removeid = 16;
        Procedure.psendWhileCommit((long)this.roleId, (Protocol)send);
        return true;
    }
}

